<?php
/**
 * Sevice Database
 * @author jf
 * @uses mysqli
 *
 * Ärver från mysqli och gör några egna metoder
 */
class service_db extends mysqli {

  public function __construct($db_settings) {
    parent::__construct($db_settings['HostName'],$db_settings['UserName'],$db_settings['Password'], $db_settings['DatabaseName']);
    if ($this->errno) {
      printf("Connect failed: %s\n", $this->connect_error);
      exit;
    }
    if (!$this->set_charset($db_settings['Charset'])) {
      printf("Error loading character set ".$db_settings['Charset'].": %s\n", $this->error);
      exit;
    }
  }

  public function Query($query) {
    // Accessing Overridden Method, har get den samma namn för att visa att man kan komma åt parent funktionen
    $result = parent::query($query);
    if (false === $result) {
      echo '<div class="error">
      <b>Det blev ett fel i följade fråga:</b><br />
      ' . nl2br($query) . '
      <b><br />MySQL säger:</b><br />
      ' . $this->error . '</div>';
      exit; // Blir det fel hoppar vi ut på en gång...
    }
    return $result;
  }

  public function GetRow($query) {
    if ($result = $this->Query($query)) {
      return $result->fetch_assoc();
    }
    return false;
  }

  public function GetAll($query) {
    if ($result = $this->Query($query)) {
      $ret = array();
      while ($row = $result->fetch_assoc()) {
        $ret[] = $row;
      }
      return $ret;
    }
    return false;
  }

  public function NumRows($query) {
    if ($result = $this->Query($query)) {
      return $result->num_rows;
    }
    return false;
  }

  public function Delete($query) {
    if ($result = $this->Query($query)) {
      return $this->affected_rows;
    }
    return false;
  }

  public function Update($table, $data, $where) {
    $query = "UPDATE `" . $table . "` SET ";
    foreach ($data as $key=>$value) {
      $query .= $key . "='".$value ."',";
    }
    $query = substr($query, 0, -1);
    $query .= " WHERE " . $where . " LIMIT 1";
    $this->Query($query);
    return $this->affected_rows;
  }

  public function Insert($table, $data) {
    $query = "INSERT INTO `" . $table . "` (";
    foreach ($data as $key=>$value) {
      $query .= "`" . $key . "`,";
    }
    $query = substr($query, 0, -1);
    $query .= " ) VALUES (";
    foreach ($data as $key=>$value) {
      $query .= "'" . $value  . "',";
    }
    $query = substr($query, 0, -1);
    $query .= " )";
    $this->Query($query);
    return $this->insert_id;
  }

}


